Package: netprioR
Title: A model for network-based prioritisation of genes
Description: A model for semi-supervised prioritisation of genes
        integrating network data, phenotypes and additional prior
        knowledge about TP and TN gene labels from the literature or
        experts.
Imports: stats, Matrix, dplyr, doParallel, foreach, parallel,
        sparseMVN, ggplot2, gridExtra, pROC
Depends: methods, graphics, R(>= 3.3)
Suggests: knitr, BiocStyle, pander
VignetteBuilder: knitr
biocViews: ImmunoOncology, CellBasedAssays, Preprocessing, Network
Type: Package
Lazyload: yes
LazyData: true
Version: 1.37.0
Date: 2016-05-08
Author: Fabian Schmich
Maintainer: Fabian Schmich <fabian.schmich@bsse.ethz.ch>
License: GPL-3
URL: http://bioconductor.org/packages/netprioR
RoxygenNote: 5.0.1
NeedsCompilation: no
git_url: https://git.bioconductor.org/packages/netprioR
git_branch: devel
git_last_commit: d000a44
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-30
Packaged: 2025-10-30 22:11:52 UTC; biocbuild

#' Fit netprioR model
#' 
#' Infer parameters and hidden data using the EM algorithm of netprioR
#' 
#' @author Fabian Schmich
#' @import Matrix
#' @import dplyr
#' @importFrom stats runif rnorm
#' @importFrom sparseMVN dmvn.sparse rmvn.sparse
#' @importFrom doParallel registerDoParallel
#' @importFrom parallel detectCores
#' @importFrom foreach foreach %dopar%
#' @param Yobs Observed labels (NA, if not observed)
#' @param X Phenotypes
#' @param G Graph Laplacians
#' @param l Indices of labelled instances
#' @param u Indices of unlabelled instances
#' @param a Shape parameter of Gamma prior for W
#' @param b Scale parameter of Gamma prior for W
#' @param sigma2 Cariance for Gaussian labels
#' @param tau2 Variance for Gaussian prior for beta
#' @param eps Small value added to diagonal of Q in order to make it non-singular
#' @param max.iter Maximum number of iterations for EM
#' @param thresh Threshold for termination of EM with respect to change in parameters
#' @param use.cg Flag whether to use conjugate gradient instead of exact computation of expectations
#' @param thresh.cg Threshold for the termination of the conjugate gradient solver
#' @param nrestarts Number of restarts for EM
#' @param max.cores Maximum number of cores to use for parallel computation
#' @param verbose Print verbose output
#' @return List containing: Predicted labels Yhat and inferred parameters W and beta
learn <- function(Yobs, X, G, l, u, a = 0.1, b = 0.1, sigma2 = 1, tau2 = 10, eps = 1e-11, max.iter = 500, 
                  thresh = 1e-3, use.cg = TRUE, thresh.cg = 1e-5, nrestarts =  5, max.cores = detectCores(), verbose = FALSE) {
  ## Initialise variables and settings
#   options(digits = 17)
  K <- length(G)
  N <- length(Yobs)
  P <- ncol(X)
  R.new <- rep(0, N)
  Yimp <- vector(length = N)
  loglik <- loglik.new <- -.Machine$double.xmin
  conv <- 1
  Smat <- sigma2 * Diagonal(N)
  Tmat <- tau2 * Diagonal(P)
  logliks <- c()
  
  ## Initialise multicore
  if(nrestarts > 1 & max.cores > 1) {
    registerDoParallel(cores = min(nrestarts, max.cores))
  }
  
  EM.runs <- foreach (runs = 1:nrestarts) %dopar% {
    W <- W.new <- runif(K, min = 1, max = 1000) #rgamma(n = K, shape = a, rate = b) #rep(1, K)
    beta <- beta.new <- rmvn.sparse(n = P, mu = rep(0, P), CH = Cholesky(Tmat), prec = FALSE)
    Q <- sapply(1:K, function(k) W[k] * G[[k]]) %>% Reduce("+", .) + eps * Diagonal(N)
    for (i in 1:max.iter) {
      ## Expectation Step
      ## E[R]
      H <- Yobs - X %*% beta
      if (use.cg) {
        E_RL <- solve(solve(Smat[l,l]) + Q[l,l]) %*% Q[l,l] %*% H[l]
        E_RU <- conjugate_gradient(A = Q[u,u], b = -Q[u,l] %*% E_RL, threshold = thresh.cg, verbose = FALSE)
      } else {
        E_RL <- solve(solve(Smat[l,l]) + Q[l,l]) %*% Q[l,l] %*% H[l]
        E_RU <- solve(Q[u,u]) %*% -Q[u,l] %*% E_RL
      }   
      R.new[u] <- E_RU %>% as.numeric
      R.new[l] <- E_RL %>% as.numeric
      
      ## E[Yu]
      E_YU = (R.new + X %*% beta)[u] %>% as.numeric
      Yimp[l] <- Yobs[l]
      Yimp[u] <- E_YU
      
      ## Maximisation step: W, beta
      W.new <- sapply(1:K, function(k) ((a - 1 + N/2) / (b + 0.5 * (R.new %*% G[[k]] %*% R.new))) %>% as.numeric)
      beta.new <- solve(t(X[l, drop = FALSE]) %*% solve(Smat[l,l]) %*% X[l, drop = FALSE] + solve(Tmat)) %*% t(X[l, drop = FALSE]) %*% solve(Smat[l,l]) %*% (Yimp[l] - R.new[l])
      #       beta.new <- solve(t(X) %*% solve(Smat) %*% X + solve(Tmat)) %*% t(X) %*% solve(Smat) %*% (Yimp - R.new)
      
      ## Compute precision matrix
      Q <- sapply(1:K, function(k) W.new[k] * G[[k]]) %>% Reduce("+", .) + eps * Diagonal(N)
      
      ## Compute log liklihood up to constants
      loglik.new <- c(- t(Yimp - (X %*% beta.new + R.new))[l] %*%
                        solve(Smat[l,l]) %*%
                        (Yimp - (X %*% beta.new + R.new))[l],
                      - t(R.new) %*% Q %*% R.new,
                      - t(beta.new) %*% solve(Tmat) %*% beta.new,
                      (a - 1) * log(W.new) - b * W.new) %>% sapply(as.numeric) %>% sum
      
      # loglik.new <- c(dmvn.sparse(x = Yimp[l], mu = (X %*% beta.new + R.new)[l] %>% as.numeric, CH = Cholesky(Smat[l,l]), prec = FALSE),
      #                 dmvn.sparse(x = R.new, mu = rep(0, N), CH = Cholesky(Q), prec = TRUE),
      #                 dmvn.sparse(x = beta.new %>% as.numeric, mu = rep(0, P), CH = Cholesky(Tmat), prec = FALSE),
      #                 dgamma(x = W.new, shape = a, rate = b, log = TRUE)) %>% sum

      logliks <- c(logliks, loglik.new)
      
      ## Check convergence
      conv <- abs((loglik.new - loglik) / loglik)
      if (verbose) {
        cat(i, "iteration: ", conv, "\n")
        #cat("W: ", W.new %>% as.numeric, "\n")
        cat("beta: ", beta.new %>% as.numeric, "\n")
        print(data.frame(G = names(G), W = W.new) %>% tbl_df %>% arrange(desc(W)) %>% data.frame)
        cat("loglik: ", loglik.new %>% as.numeric, "\n\n")
      }
      
      ## Terminate if loglik doesn't change more than given eps
      if(conv < thresh) {
        break
      } else {
        ## Update parameters
        W <- W.new
        beta <- beta.new
        loglik <- loglik.new
      }
      
    }
    W.new <- as.numeric(W.new)
    names(W.new) <- names(G)
    beta.new <- as.numeric(beta.new)
    names(beta.new) <- colnames(X)
    return(list(Yimp = Yimp,
                R = R.new %>% as.numeric,
                W = W.new,
                beta = beta.new,
                logliks = logliks))
  }
  ## Select run with maximum liklihood
  maxlikind <- lapply(EM.runs, function(x) {
    tail(x$logliks, n = 1)
  }) %>% unlist %>% which.max
  return(EM.runs[[maxlikind]])
}

#' Graph Laplacian
#' 
#' Compute the Laplacian matrix of a graph given its adjacency matrix
#'
#' @author Fabian Schmich
#' @import Matrix
#' @param x Adjacency matrix
#' @param norm Type of normalisation
#' @return Laplacian matrix
laplacian <- function(x, norm = c("none", "sym", "asym")) {
  norm <- match.arg(norm)
  stopifnot(nrow(x) == ncol(x)) 
  d <- rowSums(x)
  dsqrt <- sapply(d, function(x) ifelse(x == 0, 0, 1/sqrt(x)))
  D <- Diagonal(x = d)
  if (!is.null(dimnames(x))) dimnames(D) <- dimnames(x)
  L <- D - x
  switch(norm,
         none = L,
         sym = Diagonal(x = dsqrt) %*% L %*% Diagonal(x = dsqrt),
         asym = solve(D) %*% L)
}


#' Conjugate Gradient Solver
#' 
#' Solves linear equation systems iteratively
#' 
#' @author Fabian Schmich
#' @import Matrix
#' @param A Matrix
#' @param b Coefficients
#' @param x0 Starting solution
#' @param threshold Termination threshold
#' @param verbose Show iterative progress
#' @return Solution for equation system
conjugate_gradient <- function(A, b, x0 = rep(0, ncol(A)), threshold = 1e-15, verbose = FALSE) {
  r0 <- A %*% x0 - b
  p0 <- -r0  
  k <- 0
  rk <- r0
  pk <- p0
  xk <- x0  
  while (as.numeric(t(rk) %*% rk) > threshold) {
    ak <- as.numeric(t(rk) %*% rk / t(pk) %*% A %*% pk)
    xkp1 <- xk + ak * pk
    rkp1 <- rk + ak * A %*% pk
    bkp1 <- as.numeric(t(rkp1) %*% rkp1 / t(rk) %*% rk)
    pkp1 <- -rkp1 + bkp1 * pk    
    if (verbose)  print(sprintf("r%d: %.10f", k, as.numeric(t(rk) %*% rk)))   
    k <- k + 1
    rk <- rkp1
    pk <- pkp1
    xk <- xkp1
  }
  return(xkp1)
}

#' Class Mass Normalization (CMN) from Zhu et al., 2003
#' 
#' @author Fabian Schmich
#' @import Matrix
#' @importFrom stats pnorm
#' @param yhat Response for labeled (l) and unlabeld (u) genes
#' @param l Indices of labeled genes
#' @param u Indices of unlabeled genes
#' @return Class normalized yhat
cmn <- function(yhat, l, u) {
  fL <- cbind(pnorm(yhat[l]), 1 - pnorm(yhat[l]))
  fU <- cbind(pnorm(yhat[u]), 1 - pnorm(yhat[u]))
  N <- nrow(fU) + nrow(fL)
  q <- (colSums(fL) + 1)
  print(q)
  ans <- fU * Matrix(rep(q / colSums(fU), each = N - nrow(fL)), nrow = N - nrow(fL))
  apply(ans, 1, function(x) ifelse(x[1] > x[2], 1, 0))
}

#' bandwidth
#' 
#' Compute the bandwidth of a matrix
#'
#' @author Fabian Schmich
#' @import Matrix
#' @param x Inpute matrix
#' @return Bandwidth
bandwidth <- function(x) {
  k1 <- sapply(1:nrow(x), function(r) r - min(which(x[r,] != 0)))
  k2 <- sapply(1:nrow(x), function(r) max(which(x[r,] != 0)) - r)
  k <- pmax(k1, k2)
  return(max(k))
}

#' Cuthill McKee (CM) algorithm
#' 
#' Transform sparse matrix into a band matrix
#' 
#' @author Fabian Schmich
#' @import Matrix
#' @param x Input matrix
#' @return Band matrix
cuthill_mckee <- function(x) {
  degs <- data.frame(Idx=1:ncol(x), NonZero=apply(x, 1, function(x) length(which(x != 0))))
  R <- degs$Idx[which.min(degs$NonZero)]
  i <- 1
  for (i in 1:ncol(x)) {
    Ai <- setdiff(which(x[R[i],] != 0), R)
    if (length(Ai) > 0) {
      Ai <- Ai[order(degs$NonZero[Ai], decreasing = FALSE)]
      R <- append(R, Ai)
    } else {
      R <- append(R, degs$Idx[-R][which.min(degs$NonZero[-R])])
    }
    i <- i + 1
  }
  rR <- rev(R)
  return(x[rR, rR])
}

#' Normalise kernel
#' 
#' adopted from GeneMania, Mostafavi et al, 2009
#' 
#' @author Fabian Schmich
#' @import Matrix
#' @param x kernel
#' @return Normalised kernel
norm_kern <- function(x) {
  x <- x - diag(x)
  nz.ind <- which(x != 0, arr.ind = TRUE)
  nz.val <- x[nz.ind]
  colsums.sqrt <- sapply(colSums(x), function(i) 1/sqrt(i))
  for (i in 1:nrow(nz.ind)) {
    rr <- colsums.sqrt[nz.ind[i,1]]
    cc <- colsums.sqrt[nz.ind[i,2]]
    nz.val[i] <- nz.val[i] * rr * cc
  }
  x[nz.ind] <- nz.val
  return(x)
}

#' @export
if (!isGeneric("summary")) {
  setGeneric(name = "summary",
             def = function(object, ...) {
               standardGeneric("summary")
             },
             package = "netprioR"
  )  
}
setMethod(f = "summary",
          signature = signature(object = "netprioR"),
          definition = function(object) {
            show(object)
            cat("Model: ")
            if (object@is.fitted) {
              cat("\nLikelihood[log]:", tail(object@model$logliks, n = 1), "\n")
              cat("Fixed effects:", object@model$beta, "\n")
              cat("Network weights:\n")
              print(data.frame(Network = names(object@model$W), Weight = object@model$W), 
                    quote = FALSE, row.names = FALSE)
            } else {
              cat("not fitted.\n")
            }    
          }
)

setMethod(f = "show",
          signature = signature(object = "netprioR"),
          definition = function(object) {
            cat("#Genes:", length(object@labels), "\n")
            cat("#Networks: ", length(object@networks), "\n")
            cat("#Phenotypes:", ncol(object@phenotypes), "\n")
            cat("#Labels:", length(which(!is.na(object@labels))), "\n")
            cat("Classes:", levels(object@labels), "\n")
          }
)

#' Simulate scalefree networks
#'
#' Simulate scale free networks for predefined number of members for each of
#' two groups and a parameter pclus that determines how strictly distinct the groups
#' are
#' 
#' @author Fabian Schmich
#' @import Matrix
#' @export 
#' @param nmemb Vector of numbers of members per group
#' @param pclus Scalar in [0, 1] determining how strictly distinct groups are
#' @return Adjacency matrix
#' @examples 
#' network <- simulate_network_scalefree(nmemb = c(10, 10), pclus = 0.8)
simulate_network_scalefree <- function(nmemb, pclus = 1) {
  N <- sum(nmemb)
  names <- paste(rep(LETTERS[1:length(nmemb)], nmemb), sapply(nmemb, function(x) 1:x), sep = "")
  X <- Matrix(0, nrow = N, ncol = N, dimnames = list(names, names))  
  for (r in 1:length(nmemb)) {
    offs <- ifelse(r == 1, 0, nmemb[1:(r-1)] %>% sum)
    grpset <- seq(offs + 1, offs + nmemb[r])
    for (i in 1:length(grpset)) {
      if (runif(1) <= pclus) {
        gset <- setdiff(grpset, offs + i) # all nodes in the group but itself
      } else {
        gset <- setdiff(1:N, grpset) # all nodes in the other groups
      }
      if (all(colSums(X[gset,gset]) == 0)) { # 1st vertex
        at <- sample(gset, size = 1, replace = FALSE)
      } else { # preferential attachment
        at <- sample(gset, 
                     size = 1,
                     prob = colSums(X[gset, gset]) / sum(colSums(X[gset, gset])),
                     replace = FALSE)
      }
      X[at, offs + i] <- X[offs + i, at] <- 1
    }
  }
  if(any(colSums(X) == 0)) stop("Created un-attached vertex")
  return(X)
}

#' Simulate random networks with predefined number of members for each
#' of the two groups and the number of neighbours for each node
#' 
#' @author Fabian Schmich
#' @import Matrix
#' @export
#' @param nmemb Vector of number of members for each group
#' @param nnei Number of neighbours for each node
#' @return Adjacency matrix of graph
#' @examples
#' network <- simulate_network_random(nmemb = c(10, 10), nnei = 1)
simulate_network_random <- function(nmemb, nnei = 1) {
  N <- sum(nmemb)
  names <- paste(rep(LETTERS[1:length(nmemb)], nmemb), sapply(nmemb, function(x) 1:x), sep = "")
  X <- Matrix(0, nrow = N, ncol = N, dimnames = list(names, names))  
  for (i in 1:nrow(X)) {
    neis <- sample(setdiff(1:N, i), size = nnei, replace = FALSE)
    X[i,neis] <- X[neis,i] <- 1
  }
  return(X)
}


#' Simulate labels
#' 
#' @author Fabian Schmich
#' @import dplyr
#' @export
#' @param values Vector of labels for groups
#' @param sizes Vector of group sizes
#' @param nobs Vector of number of observed labels per group
#' @return List of Y, Yobs and indices for labeled instances
#' @examples 
#' labels <- simulate_labels(values = c("Positive", "Negative"), 
#' sizes = c(10, 10), 
#' nobs = c(5, 5))
simulate_labels <- function(values, sizes, nobs) {
  stopifnot(length(sizes) == length(values) & length(nobs) == length(values))
  Y <- lapply(1:length(values), function(i) rep(values[i], sizes[i])) %>% do.call("c", .)
  l <- sapply(1:length(values), function(i) {
    if (i == 1) {
      sampfrom <- (1:sizes[i])
    } else {
      sampfrom <- (sizes[1:(i-1)] %>% sum + 1):(sizes[1:(i-1)] %>% sum + sizes[i])
    }
    sample(sampfrom, nobs[i]) 
  }) %>% unlist %>% as.numeric %>% sort
  u <- setdiff(1:length(Y), l)
  Yobs <- Y
  Yobs[u] <- NA
  return(list(labels.true = factor(Y), labels.obs = factor(Yobs), labelled = l, unlabelled = u))
}

#' Simulate phenotypes correlated to labels pivoted into two groups
#' 
#' @author Fabian Schmich
#' @import Matrix
#' @import dplyr
#' @export
#' @param labels.true Vector of labels
#' @param meandiff difference of means between positive and negative groups
#' @param sd Standard deviation of the phenotype
#' @return Simulated phenotype
#' @examples 
#' data(simulation)
#' phenotypes <- simulate_phenotype(labels.true = simulation$labels.true, meandiff = 0.5, sd = 1)
simulate_phenotype <- function(labels.true, meandiff, sd) {
  stopifnot(length(levels(labels.true)) == 2)
  X <-  rep(NA, length(labels.true)) %>% cbind
  s0 <- which(labels.true == levels(labels.true)[1])
  b0 <- which(labels.true == levels(labels.true)[2])
  X[s0] <- rnorm(length(s0), -meandiff/2, sd)
  X[b0] <- rnorm(length(b0), +meandiff/2, sd)
  return(X)
}

#' Retrieve network weights
#'
#' @author Fabian Schmich
#' @rdname weights-methods
#' @export
#' @param object A \code{\linkS4class{netprioR}} object 
#' @param ... Additional arguments
#' @return Estimated network weights
setGeneric(name = "weights", def = function(object) standardGeneric("weights"))
#' @rdname weights-methods
#' @examples 
#' data(simulation)
#' weights(simulation$model)
setMethod(f = "weights",
          signature = signature(object = "netprioR"),
          function(object) {
            Network <- Weight <- NULL
            if(object@is.fitted) {
              ans <- data.frame(Network = names(object@model$W), Weight = object@model$W) %>%
                tbl_df %>%
                arrange(desc(Weight))
              rownames(ans) <- c()
              return(ans)
            } else {
              warning("No fitted model.")
            }
          }
)

#' Retrieve ranked prioritisation list
#' 
#' @author Fabian Schmich
#' @rdname ranks-methods
#' @import dplyr
#' @param object A \code{\linkS4class{netprioR}} object 
#' @return Ranked list of prioritised genes
#' @export
setGeneric(name = "ranks", def = function(object) standardGeneric("ranks"))
#' @rdname ranks-methods
#' @examples 
#' data(simulation)
#' ranks(simulation$model)
setMethod(f = "ranks",
          signature = signature(object = "netprioR"),
          function(object) {
            Score <- Rank <- Id <- NULL
            if(object@is.fitted) {
              unlabelled <- which(is.na(object@labels))
              # Try to find labels somewhere
              if (!is.null(rownames(object@phenotypes))) {
                ids <- rownames(object@phenotypes)
              } else if (!is.null(names(object@labels))) {
                ids <- names(object@labels)
              } else {
                ids <- 1:length(object@labels)  
              }
              data.frame(Id = ids[unlabelled], 
                         Score = object@model$Yimp[unlabelled]) %>%
                tbl_df %>%
                arrange(desc(Score)) %>%
                mutate(Rank = 1:length(unlabelled)) %>%
                select(Rank, Id, Score)
            } else {
              warning("No fitted model.")
            }
          }
)

#' Compute ROC curve from netprioR model and true labels
#'
#' @author Fabian Schmich
#' @rdname ROC-methods
#' @importFrom pROC roc plot.roc
#' @param object A \code{\linkS4class{netprioR}} object 
#' @param true.labels True full set of underlying labels
#' @param plot Flag whether to plot the AUC curve
#' @param ... Additional arguments
#' @return ROC curve with AUC
#' @export
setGeneric(name = "ROC", def = function(object, ...) standardGeneric("ROC"))
#' @rdname ROC-methods
#' @examples 
#' data(simulation)
#' ROC(simulation$model, true.labels = simulation$labels.true)
setMethod(f = "ROC",
          signature = signature(object = "netprioR"),
          function(object, true.labels, plot = FALSE, ...) {
            if(object@is.fitted) {
              stopifnot(length(object@model$Yimp) == length(true.labels))
              stopifnot((levels(object@labels)) == levels(true.labels))
              stopifnot(length(levels(true.labels)) == 2)
              unlabelled <- which(is.na(object@labels))
              ans <- roc(cases = object@model$Yimp[intersect(unlabelled, which(true.labels == levels(true.labels)[1]))], 
                         controls = object@model$Yimp[intersect(unlabelled, which(true.labels == levels(true.labels)[2]))],
                         direction = ">")
              if (plot) plot.roc(ans, print.auc = TRUE, print.auc.x = 0.2, print.auc.y = 0.1, ...)
              return(ans)
            } else {
              warning("No fitted model.")
            }
          }
)


#' Fit \code{\linkS4class{netprioR}} model
#'
#' @author Fabian Schmich
#' @rdname fit-methods
#' @export
#' @param object A \code{\linkS4class{netprioR}} object 
#' @param refit Flag whether to overwrite existing fit
#' @param ... Additional arguments
#' @return A \code{\linkS4class{netprioR}} object with fitted model
setGeneric(name = "fit", def = function(object, ...) standardGeneric("fit"))
#' @rdname fit-methods
#' @examples 
#' data(simulation)
#' np <- netprioR(networks = simulation$networks,
#'                phenotypes = simulation$phenotypes,
#'                labels = simulation$labels.obs,
#'                model.fit = FALSE)
#' summary(np)
#' np <- fit(np, nrestarts = 1, verbose = FALSE)
#' summary(np)
setMethod(f = "fit",
          signature = signature(object = "netprioR"),
          function(object, refit = FALSE, ...) {
            if(!object@is.fitted) {
              netprioR(networks = object@networks,
                       phenotypes = object@phenotypes,
                       labels = object@labels,
                       fit.model = TRUE,
                       ...)
            } else if (refit) {
              netprioR(networks = object@networks,
                       phenotypes = object@phenotypes,
                       labels = object@labels,
                       fit.model = TRUE,
                       ...)
            } else {
              warning("Set refit = TRUE, if existing fit should be overwritten.")
              return(object)
            }
          }
)

#' Package: netprioR
#' 
#' This package provides a model for semi-supervised prioritisation of genes integrating network data, 
#' phenotypes and additional prior knowledge about TP and TN gene labels.
#' 
#' @name netprioR-package
#' @author Fabian Schmich | Computational Biology Group, ETH Zurich | \email{fabian.schmich@@bsse.ethz.ch}
#' @docType package
#' @keywords package
#' @references Fabian Schmich et. al (2016).
#' @import methods
#' @importFrom graphics plot
globalVariables(".")

#' Example data: Simulated networks, phenotypes and labels for N = 1000 genes
#' 
#' The data set contains simulated data for N = 1000 genes and P = 1 (univariate) phenotypes. 
#' The list of networks contains 2 low noise networks and two high noise networks. The class
#' labels are "Positive" and "Negative".
#' 
#' The code used to simluate the data can be found in system.file("example", "data_simulation.R", package = "netprioR")
#' 
#' @docType data
#' @name simulation
#' @return List of simulated networks, phenotypes and labels for 1000 genes
#' @usage data(simulation)
NA

#' netprioR
#' 
#' Class that represents a netprioR model.
#' 
#' @author Fabian Schmich
#' @name netprioR-class
#' @rdname netprioR-class
#' @aliases netprioR
#' 
#' @import dplyr
#' @exportClass netprioR
#'
#' @slot networks List of NxN adjacency matrices of gene-gene similarities
#' @slot phenotypes Matrix of dimension NxP containing covariates
#' @slot labels Vector of Nx1 labels for all genes. NA if no label available. 
#' @slot is.fitted Flag indicating if model is fitted
#' @slot model List containing estimated parameters and imputed missing data
#' 
setClass(Class = "netprioR",
         representation = representation(
           networks = "list",
           phenotypes = "matrix",
           labels = "factor",
           is.fitted = "logical",
           model = "list"
         ),
         validity=function(object) {
           return(TRUE)
           # TODO: implement validity check
         }
)

#' @rdname netprioR-class
#' @exportMethod netprioR
#'
#' @param networks List of NxN adjacency matrices of gene-gene similarities
#' @param phenotypes Matrix of dimension NxP containing covariates
#' @param labels Vector of Nx1 labels for all genes (NA if no label available)
#' @param fit.model Indicator whether to fit the model
#' @param a Shape parameter of Gamma prior for W
#' @param b Scale parameter of Gamma prior for W
#' @param sigma2 Cariance for Gaussian labels
#' @param tau2 Variance for Gaussian prior for beta
#' @param eps Small value added to diagonal of Q in order to make it non-singular
#' @param max.iter Maximum number of iterations for EM
#' @param thresh Threshold for termination of EM with respect to change in parameters
#' @param use.cg Flag whether to use conjugate gradient instead of exact computation of expectations
#' @param thresh.cg Threshold for the termination of the conjugate gradient solver
#' @param nrestarts Number of restarts for EM
#' @param max.cores Maximum number of cores to use for parallel computation
#' @param verbose Print verbose output
#' @param ... Additional arguments
#' @return A \code{\linkS4class{netprioR}} object
setGeneric("netprioR",
           function(networks, phenotypes, labels, ...) {
             standardGeneric("netprioR")
           })
#' @rdname netprioR-class
#' @examples 
#' \donttest{ # runs long-ish
#' data(simulation)
#' np <- netprioR(networks = simulation$networks,
#'                phenotypes = simulation$phenotypes,
#'                labels = simulation$labels.obs,
#'                fit.model = TRUE)
#' summary(np)          
#' }
setMethod("netprioR",
          signature = signature(networks = "list", 
                                phenotypes = "matrix",
                                labels = "factor"),
          function(networks, 
                   phenotypes, 
                   labels,
                   fit.model = FALSE,
                   a = 0.1,
                   b = 0.1,
                   sigma2 = 0.1,
                   tau2 = 100,
                   eps = 1e-10,
                   max.iter = 500,
                   thresh = 1e-6,
                   use.cg = FALSE,
                   thresh.cg = 1e-6,
                   nrestarts = 5,
                   max.cores = detectCores(),
                   verbose = TRUE,
                   ...){
            stopifnot(length(levels(labels)) == 2)
            if (fit.model) {
              labelled <- which(!is.na(labels))
              unlabelled <- setdiff(1:length(labels), labelled)
              Yobs <- factor(labels, labels = c(-1, +1)) %>% as.character %>% as.numeric
              G <- lapply(networks, function(x) {
                x <- x / norm(x)
                return(laplacian(x, norm = "none"))
              })
              model <- learn(Yobs = Yobs,
                             G = G,
                             X = phenotypes,
                             l = labelled,
                             u = unlabelled,
                             a = a,
                             b = b,
                             sigma2 = sigma2,
                             tau2 = tau2,
                             eps = eps,
                             max.iter = max.iter,
                             thresh = thresh,
                             use.cg = use.cg,
                             nrestarts = nrestarts,
                             max.cores = max.cores,
                             verbose = verbose)
              
              new("netprioR",
                  networks = networks,
                  phenotypes = phenotypes,
                  labels = labels,
                  model = model,
                  is.fitted = TRUE)
            } else {
              new("netprioR",
                  networks = networks,
                  phenotypes = phenotypes,
                  labels = labels,
                  model = list(),
                  is.fitted = FALSE)
            }
          }
)

#' Plot method for \code{\linkS4class{netprioR}} objects
#' 
#' @author Fabian Schmich
#' @import ggplot2
#' @import dplyr
#' @importFrom gridExtra grid.arrange
#' @export
#' @method plot netprioR
#' 
#' @param x A \code{\linkS4class{netprioR}} object
#' @param which Flag for which plot should be shown, options: weights, lik, scores, all
#' @param ... Additional paramters for plot
#' @return Plot of the weights, likelihood, ranks, or all three
#' @examples 
#' data(simulation)
#' plot(simulation$model)
plot.netprioR <- function(x, which = c("all", "weights", "lik", "scores"), ...) {
  which <- match.arg(which)
  Weight <- Network <- Iteration <- Loglik <- Score <- Rank <- Id <- NULL
  if (x@is.fitted) {
    pl.weights <- ggplot(weights(x) %>% 
                           mutate(Weight = Weight / sum(Weight)) %>%
                           arrange(desc(Weight)) %>%
                           mutate(Network = factor(Network, levels = Network)), 
                         aes(x = Network, y = Weight)) + 
      geom_bar(stat = "identity") + 
      ylab("Relative weight") + 
      ggtitle("Network weights") +
      theme_bw() +
      theme(axis.text.x = element_text(angle = 45, hjust = 1))
    pl.lik <-ggplot(data.frame(Iteration = 2:length(x@model$logliks), Loglik = x@model$logliks[-1]), aes(x = Iteration, y = Loglik)) + 
      geom_line() + 
      scale_y_continuous(labels = function(x) format(x, nsmall = 2, scientific = TRUE)) +
      ylab("Likelihood [log]") + 
      ggtitle("EM iterations") +
      theme_bw()
    pl.scores <- ggplot(ranks(x), aes(x = Score)) + geom_histogram(binwidth = 0.1) + 
      ylab("Count") +
      ggtitle("Prioritisation") +
      theme_bw()
    switch(which,
           "weights" = pl.weights,
           "lik" = pl.lik,
           "scores" = pl.scores,
           "all" = grid.arrange(pl.lik, pl.weights, pl.scores, ncol = 1)
    )
  } else {
    warning("No model fitted.")
  }
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netprioR-simulation.R
\name{simulate_network_scalefree}
\alias{simulate_network_scalefree}
\title{Simulate scalefree networks}
\usage{
simulate_network_scalefree(nmemb, pclus = 1)
}
\arguments{
\item{nmemb}{Vector of numbers of members per group}

\item{pclus}{Scalar in [0, 1] determining how strictly distinct groups are}
}
\value{
Adjacency matrix
}
\description{
Simulate scale free networks for predefined number of members for each of
two groups and a parameter pclus that determines how strictly distinct the groups
are
}
\examples{
network <- simulate_network_scalefree(nmemb = c(10, 10), pclus = 0.8)
}
\author{
Fabian Schmich
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netprioR-simulation.R
\name{simulate_network_random}
\alias{simulate_network_random}
\title{Simulate random networks with predefined number of members for each
of the two groups and the number of neighbours for each node}
\usage{
simulate_network_random(nmemb, nnei = 1)
}
\arguments{
\item{nmemb}{Vector of number of members for each group}

\item{nnei}{Number of neighbours for each node}
}
\value{
Adjacency matrix of graph
}
\description{
Simulate random networks with predefined number of members for each
of the two groups and the number of neighbours for each node
}
\examples{
network <- simulate_network_random(nmemb = c(10, 10), nnei = 1)
}
\author{
Fabian Schmich
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netprioR-functions.R
\name{laplacian}
\alias{laplacian}
\title{Graph Laplacian}
\usage{
laplacian(x, norm = c("none", "sym", "asym"))
}
\arguments{
\item{x}{Adjacency matrix}

\item{norm}{Type of normalisation}
}
\value{
Laplacian matrix
}
\description{
Compute the Laplacian matrix of a graph given its adjacency matrix
}
\author{
Fabian Schmich
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netprioR-methods.R
\docType{methods}
\name{ROC}
\alias{ROC}
\alias{ROC,netprioR-method}
\title{Compute ROC curve from netprioR model and true labels}
\usage{
ROC(object, ...)

\S4method{ROC}{netprioR}(object, true.labels, plot = FALSE, ...)
}
\arguments{
\item{object}{A \code{\linkS4class{netprioR}} object}

\item{...}{Additional arguments}

\item{true.labels}{True full set of underlying labels}

\item{plot}{Flag whether to plot the AUC curve}
}
\value{
ROC curve with AUC
}
\description{
Compute ROC curve from netprioR model and true labels
}
\examples{
data(simulation)
ROC(simulation$model, true.labels = simulation$labels.true)
}
\author{
Fabian Schmich
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netprioR-methods.R
\docType{methods}
\name{ranks}
\alias{ranks}
\alias{ranks,netprioR-method}
\title{Retrieve ranked prioritisation list}
\usage{
ranks(object)

\S4method{ranks}{netprioR}(object)
}
\arguments{
\item{object}{A \code{\linkS4class{netprioR}} object}
}
\value{
Ranked list of prioritised genes
}
\description{
Retrieve ranked prioritisation list
}
\examples{
data(simulation)
ranks(simulation$model)
}
\author{
Fabian Schmich
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netprioR-functions.R
\name{learn}
\alias{learn}
\title{Fit netprioR model}
\usage{
learn(Yobs, X, G, l, u, a = 0.1, b = 0.1, sigma2 = 1, tau2 = 10,
  eps = 1e-11, max.iter = 500, thresh = 0.001, use.cg = TRUE,
  thresh.cg = 1e-05, nrestarts = 5, max.cores = detectCores(),
  verbose = FALSE)
}
\arguments{
\item{Yobs}{Observed labels (NA, if not observed)}

\item{X}{Phenotypes}

\item{G}{Graph Laplacians}

\item{l}{Indices of labelled instances}

\item{u}{Indices of unlabelled instances}

\item{a}{Shape parameter of Gamma prior for W}

\item{b}{Scale parameter of Gamma prior for W}

\item{sigma2}{Cariance for Gaussian labels}

\item{tau2}{Variance for Gaussian prior for beta}

\item{eps}{Small value added to diagonal of Q in order to make it non-singular}

\item{max.iter}{Maximum number of iterations for EM}

\item{thresh}{Threshold for termination of EM with respect to change in parameters}

\item{use.cg}{Flag whether to use conjugate gradient instead of exact computation of expectations}

\item{thresh.cg}{Threshold for the termination of the conjugate gradient solver}

\item{nrestarts}{Number of restarts for EM}

\item{max.cores}{Maximum number of cores to use for parallel computation}

\item{verbose}{Print verbose output}
}
\value{
List containing: Predicted labels Yhat and inferred parameters W and beta
}
\description{
Infer parameters and hidden data using the EM algorithm of netprioR
}
\author{
Fabian Schmich
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netprioR-functions.R
\name{norm_kern}
\alias{norm_kern}
\title{Normalise kernel}
\usage{
norm_kern(x)
}
\arguments{
\item{x}{kernel}
}
\value{
Normalised kernel
}
\description{
adopted from GeneMania, Mostafavi et al, 2009
}
\author{
Fabian Schmich
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netprioR-simulation.R
\name{simulate_labels}
\alias{simulate_labels}
\title{Simulate labels}
\usage{
simulate_labels(values, sizes, nobs)
}
\arguments{
\item{values}{Vector of labels for groups}

\item{sizes}{Vector of group sizes}

\item{nobs}{Vector of number of observed labels per group}
}
\value{
List of Y, Yobs and indices for labeled instances
}
\description{
Simulate labels
}
\examples{
labels <- simulate_labels(values = c("Positive", "Negative"), 
sizes = c(10, 10), 
nobs = c(5, 5))
}
\author{
Fabian Schmich
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netprioR-methods.R
\docType{methods}
\name{fit}
\alias{fit}
\alias{fit,netprioR-method}
\title{Fit \code{\linkS4class{netprioR}} model}
\usage{
fit(object, ...)

\S4method{fit}{netprioR}(object, refit = FALSE, ...)
}
\arguments{
\item{object}{A \code{\linkS4class{netprioR}} object}

\item{...}{Additional arguments}

\item{refit}{Flag whether to overwrite existing fit}
}
\value{
A \code{\linkS4class{netprioR}} object with fitted model
}
\description{
Fit \code{\linkS4class{netprioR}} model
}
\examples{
data(simulation)
np <- netprioR(networks = simulation$networks,
               phenotypes = simulation$phenotypes,
               labels = simulation$labels.obs,
               model.fit = FALSE)
summary(np)
np <- fit(np, nrestarts = 1, verbose = FALSE)
summary(np)
}
\author{
Fabian Schmich
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netprioR-class.R
\docType{class}
\name{netprioR-class}
\alias{netprioR}
\alias{netprioR,list,matrix,factor-method}
\alias{netprioR-class}
\title{netprioR}
\usage{
netprioR(networks, phenotypes, labels, ...)

\S4method{netprioR}{list,matrix,factor}(networks, phenotypes, labels,
  fit.model = FALSE, a = 0.1, b = 0.1, sigma2 = 0.1, tau2 = 100,
  eps = 1e-10, max.iter = 500, thresh = 1e-06, use.cg = FALSE,
  thresh.cg = 1e-06, nrestarts = 5, max.cores = detectCores(),
  verbose = TRUE, ...)
}
\arguments{
\item{networks}{List of NxN adjacency matrices of gene-gene similarities}

\item{phenotypes}{Matrix of dimension NxP containing covariates}

\item{labels}{Vector of Nx1 labels for all genes (NA if no label available)}

\item{...}{Additional arguments}

\item{fit.model}{Indicator whether to fit the model}

\item{a}{Shape parameter of Gamma prior for W}

\item{b}{Scale parameter of Gamma prior for W}

\item{sigma2}{Cariance for Gaussian labels}

\item{tau2}{Variance for Gaussian prior for beta}

\item{eps}{Small value added to diagonal of Q in order to make it non-singular}

\item{max.iter}{Maximum number of iterations for EM}

\item{thresh}{Threshold for termination of EM with respect to change in parameters}

\item{use.cg}{Flag whether to use conjugate gradient instead of exact computation of expectations}

\item{thresh.cg}{Threshold for the termination of the conjugate gradient solver}

\item{nrestarts}{Number of restarts for EM}

\item{max.cores}{Maximum number of cores to use for parallel computation}

\item{verbose}{Print verbose output}
}
\value{
A \code{\linkS4class{netprioR}} object
}
\description{
Class that represents a netprioR model.
}
\section{Slots}{

\describe{
\item{\code{networks}}{List of NxN adjacency matrices of gene-gene similarities}

\item{\code{phenotypes}}{Matrix of dimension NxP containing covariates}

\item{\code{labels}}{Vector of Nx1 labels for all genes. NA if no label available.}

\item{\code{is.fitted}}{Flag indicating if model is fitted}

\item{\code{model}}{List containing estimated parameters and imputed missing data}
}}
\examples{
\donttest{ # runs long-ish
data(simulation)
np <- netprioR(networks = simulation$networks,
               phenotypes = simulation$phenotypes,
               labels = simulation$labels.obs,
               fit.model = TRUE)
summary(np)          
}
}
\author{
Fabian Schmich
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netprioR-simulation.R
\name{simulate_phenotype}
\alias{simulate_phenotype}
\title{Simulate phenotypes correlated to labels pivoted into two groups}
\usage{
simulate_phenotype(labels.true, meandiff, sd)
}
\arguments{
\item{labels.true}{Vector of labels}

\item{meandiff}{difference of means between positive and negative groups}

\item{sd}{Standard deviation of the phenotype}
}
\value{
Simulated phenotype
}
\description{
Simulate phenotypes correlated to labels pivoted into two groups
}
\examples{
data(simulation)
phenotypes <- simulate_phenotype(labels.true = simulation$labels.true, meandiff = 0.5, sd = 1)
}
\author{
Fabian Schmich
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netprioR-package.R
\docType{package}
\name{netprioR-package}
\alias{netprioR-package}
\title{Package: netprioR}
\description{
This package provides a model for semi-supervised prioritisation of genes integrating network data, 
phenotypes and additional prior knowledge about TP and TN gene labels.
}
\author{
Fabian Schmich | Computational Biology Group, ETH Zurich | \email{fabian.schmich@bsse.ethz.ch}
}
\references{
Fabian Schmich et. al (2016).
}
\keyword{package}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netprioR-functions.R
\name{cmn}
\alias{cmn}
\title{Class Mass Normalization (CMN) from Zhu et al., 2003}
\usage{
cmn(yhat, l, u)
}
\arguments{
\item{yhat}{Response for labeled (l) and unlabeld (u) genes}

\item{l}{Indices of labeled genes}

\item{u}{Indices of unlabeled genes}
}
\value{
Class normalized yhat
}
\description{
Class Mass Normalization (CMN) from Zhu et al., 2003
}
\author{
Fabian Schmich
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netprioR-class.R
\name{plot.netprioR}
\alias{plot.netprioR}
\title{Plot method for \code{\linkS4class{netprioR}} objects}
\usage{
\method{plot}{netprioR}(x, which = c("all", "weights", "lik", "scores"), ...)
}
\arguments{
\item{x}{A \code{\linkS4class{netprioR}} object}

\item{which}{Flag for which plot should be shown, options: weights, lik, scores, all}

\item{...}{Additional paramters for plot}
}
\value{
Plot of the weights, likelihood, ranks, or all three
}
\description{
Plot method for \code{\linkS4class{netprioR}} objects
}
\examples{
data(simulation)
plot(simulation$model)
}
\author{
Fabian Schmich
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netprioR-functions.R
\name{bandwidth}
\alias{bandwidth}
\title{bandwidth}
\usage{
bandwidth(x)
}
\arguments{
\item{x}{Inpute matrix}
}
\value{
Bandwidth
}
\description{
Compute the bandwidth of a matrix
}
\author{
Fabian Schmich
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netprioR-functions.R
\name{conjugate_gradient}
\alias{conjugate_gradient}
\title{Conjugate Gradient Solver}
\usage{
conjugate_gradient(A, b, x0 = rep(0, ncol(A)), threshold = 1e-15,
  verbose = FALSE)
}
\arguments{
\item{A}{Matrix}

\item{b}{Coefficients}

\item{x0}{Starting solution}

\item{threshold}{Termination threshold}

\item{verbose}{Show iterative progress}
}
\value{
Solution for equation system
}
\description{
Solves linear equation systems iteratively
}
\author{
Fabian Schmich
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netprioR-functions.R
\name{cuthill_mckee}
\alias{cuthill_mckee}
\title{Cuthill McKee (CM) algorithm}
\usage{
cuthill_mckee(x)
}
\arguments{
\item{x}{Input matrix}
}
\value{
Band matrix
}
\description{
Transform sparse matrix into a band matrix
}
\author{
Fabian Schmich
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netprioR-package.R
\docType{data}
\name{simulation}
\alias{simulation}
\title{Example data: Simulated networks, phenotypes and labels for N = 1000 genes}
\usage{
data(simulation)
}
\value{
List of simulated networks, phenotypes and labels for 1000 genes
}
\description{
The data set contains simulated data for N = 1000 genes and P = 1 (univariate) phenotypes. 
The list of networks contains 2 low noise networks and two high noise networks. The class
labels are "Positive" and "Negative".
}
\details{
The code used to simluate the data can be found in system.file("example", "data_simulation.R", package = "netprioR")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netprioR-methods.R
\docType{methods}
\name{weights}
\alias{weights}
\alias{weights,netprioR-method}
\title{Retrieve network weights}
\usage{
weights(object, ...)

\S4method{weights}{netprioR}(object)
}
\arguments{
\item{object}{A \code{\linkS4class{netprioR}} object}

\item{...}{Additional arguments}
}
\value{
Estimated network weights
}
\description{
Retrieve network weights
}
\examples{
data(simulation)
weights(simulation$model)
}
\author{
Fabian Schmich
}
